global
  log /dev/log local0
  log localhost local1 notice
  maxconn 2000
  daemon

defaults
  log     global
  mode    http
  option  httplog
  option  dontlognull
  retries 3
  timeout connect 5000
  timeout client  50000
  timeout server  50000
  
frontend api_gateway
  bind *:${HAPROXY_PORT} ssl crt /usr/local/etc/haproxy/aas_haproxy_ssl.pem
  http-request redirect scheme https unless { ssl_fc }
  acl PATH_service1 path_beg -i /payment
  acl PATH_service2 path_beg -i /auth
  acl PATH_service3 path_beg -i /machine
  acl PATH_service4 path_beg -i /delivery
  acl PATH_service5 path_beg -i /order
  acl PATH_service6 path_beg -i /piece
  acl PATH_service7 path_beg -i /log
  acl PATH_service8 path_beg -i /user

  use_backend be_payment if PATH_service1
  use_backend be_auth if PATH_service2
  use_backend be_machine if PATH_service3
  use_backend be_delivery if PATH_service4
  use_backend be_order_piece if PATH_service5
  use_backend be_order_piece if PATH_service6
  use_backend be_log if PATH_service7
  use_backend be_auth if PATH_service8

backend be_payment
  balance roundrobin
  #option httpchk HEAD /health HTTP/1.0
  #server service1 ${SERVICE1_IP}:${SERVICE1_PORT} check inter 5s downinter 5s fall 2 rise 3 fastinter 500 ssl ca-file /usr/local/etc/haproxy/ca/aas_ca.crt
  server-template paymentapp 1 _payment._tcp.service.consul resolvers consul resolve-opts allow-dup-ip resolve-prefer ipv4 check

backend be_auth
  balance roundrobin
  #option httpchk HEAD /health HTTP/1.0
  #server service2 ${SERVICE2_IP}:${SERVICE2_PORT} check inter 5s downinter 5s fall 2 rise 3 fastinter 500 ssl ca-file /usr/local/etc/haproxy/ca/aas_ca.crt
  server-template authapp 1 _auth._tcp.service.consul resolvers consul no-check-ssl resolve-opts allow-dup-ip resolve-prefer ipv4 check

backend be_machine
  balance roundrobin
  #option httpchk HEAD /health HTTP/1.0
  #server service3 ${SERVICE3_IP}:${SERVICE3_PORT} check inter 5s downinter 5s fall 2 rise 3 fastinter 500 ssl ca-file /usr/local/etc/haproxy/ca/aas_ca.crt
  server-template machineapp 1 _machine._tcp.service.consul resolvers consul resolve-opts allow-dup-ip resolve-prefer ipv4 check

backend be_delivery
  balance roundrobin
  #option httpchk HEAD /health HTTP/1.0
  #server service2 ${SERVICE4_IP}:${SERVICE4_PORT} check inter 5s downinter 5s fall 2 rise 3 fastinter 500 ssl ca-file /usr/local/etc/haproxy/ca/aas_ca.crt
  server-template deliveryapp 1 _delivery._tcp.service.consul resolvers consul resolve-opts allow-dup-ip resolve-prefer ipv4 check

backend be_order_piece
  balance roundrobin
  #option httpchk HEAD /health HTTP/1.0
  #server service2 ${SERVICE5_IP}:${SERVICE5_PORT} check inter 5s downinter 5s fall 2 rise 3 fastinter 500 ssl ca-file /usr/local/etc/haproxy/ca/aas_ca.crt
  server-template orderpieceapp 5 _order._tcp.service.consul resolvers consul resolve-opts allow-dup-ip resolve-prefer ipv4 check

backend be_log
  balance roundrobin
  #option httpchk HEAD /health HTTP/1.0
  #server service2 ${SERVICE7_IP}:${SERVICE7_PORT} check inter 5s downinter 5s fall 2 rise 3 fastinter 500 ssl ca-file /usr/local/etc/haproxy/ca/aas_ca.crt
  server-template logapp 1 _log._tcp.service.consul resolvers consul resolve-opts allow-dup-ip resolve-prefer ipv4 check

resolvers consul
  nameserver consul 192.168.17.18:8600
  accepted_payload_size 8192
  hold valid 5s

listen stats
  bind :${HAPROXY_STATS_PORT}
  stats enable
  stats uri /
  stats hide-version
  stats auth admin:admin

# https://www.haproxy.com/blog/using-haproxy-as-an-api-gateway-part-1/
# https://www.haproxy.com/blog/using-haproxy-as-an-api-gateway-part-2-authentication/
# https://www.haproxy.com/blog/using-haproxy-as-an-api-gateway-part-3-health-checks/
